#include "apex-enums.h"

#include "proto/v1/core.pb-c.h"

/* Must cast the enums to ints to avoid enum compare warning */
#define ASSERT_ENUM(a, b) G_STATIC_ASSERT (((int) a) == ((int) b))

ASSERT_ENUM (APEX_CONFIGURATION_NAMESPACE_ACQUIRE,    APEX__CONFIGURATION__NAMESPACE__ACQUIRE);
ASSERT_ENUM (APEX_CONFIGURATION_NAMESPACE_ANALYZE,    APEX__CONFIGURATION__NAMESPACE__ANALYZE);
ASSERT_ENUM (APEX_CONFIGURATION_NAMESPACE_CONTROL,    APEX__CONFIGURATION__NAMESPACE__CONTROL);
ASSERT_ENUM (APEX_CONFIGURATION_NAMESPACE_EXPERIMENT, APEX__CONFIGURATION__NAMESPACE__EXPERIMENT);
ASSERT_ENUM (APEX_CONFIGURATION_NAMESPACE_MONITOR,    APEX__CONFIGURATION__NAMESPACE__MONITOR);
ASSERT_ENUM (APEX_CONFIGURATION_NAMESPACE_PRESENT,    APEX__CONFIGURATION__NAMESPACE__PRESENT);
ASSERT_ENUM (APEX_CONFIGURATION_NAMESPACE_RECORD,     APEX__CONFIGURATION__NAMESPACE__RECORD);
ASSERT_ENUM (APEX_CONFIGURATION_NAMESPACE_STATE,      APEX__CONFIGURATION__NAMESPACE__STATE);

ASSERT_ENUM (APEX_JOB_STATUS_TYPE_SUBMITTED,          APEX__JOB__STATUS__SUBMITTED);
ASSERT_ENUM (APEX_JOB_STATUS_TYPE_READY,              APEX__JOB__STATUS__READY);
ASSERT_ENUM (APEX_JOB_STATUS_TYPE_STARTED,            APEX__JOB__STATUS__STARTED);
ASSERT_ENUM (APEX_JOB_STATUS_TYPE_RUNNING,            APEX__JOB__STATUS__RUNNING);
ASSERT_ENUM (APEX_JOB_STATUS_TYPE_PAUSED,             APEX__JOB__STATUS__PAUSED);
ASSERT_ENUM (APEX_JOB_STATUS_TYPE_RESUMED,            APEX__JOB__STATUS__RESUMED);
ASSERT_ENUM (APEX_JOB_STATUS_TYPE_STOPPED,            APEX__JOB__STATUS__STOPPED);
ASSERT_ENUM (APEX_JOB_STATUS_TYPE_FAILED,             APEX__JOB__STATUS__FAILED);

/* FIXME: this causes an error */
/*
 *ASSERT_ENUM (APEX_CHANNEL_TYPE_SINK,                  APEX__CHANNEL__TYPE__SINK);
 *ASSERT_ENUM (APEX_CHANNEL_TYPE_SOURCE,                APEX__CHANNEL__TYPE__SOURCE);
 */

ASSERT_ENUM (APEX_SERVICE_TYPE_ACQUIRE,               APEX__SERVICE__TYPE__ACQUIRE);
ASSERT_ENUM (APEX_SERVICE_TYPE_ANALYZE,               APEX__SERVICE__TYPE__ANALYZE);
ASSERT_ENUM (APEX_SERVICE_TYPE_CONTROL,               APEX__SERVICE__TYPE__CONTROL);
ASSERT_ENUM (APEX_SERVICE_TYPE_EXPERIMENT,            APEX__SERVICE__TYPE__EXPERIMENT);
ASSERT_ENUM (APEX_SERVICE_TYPE_MONITOR,               APEX__SERVICE__TYPE__MONITOR);
ASSERT_ENUM (APEX_SERVICE_TYPE_PRESENT,               APEX__SERVICE__TYPE__PRESENT);
ASSERT_ENUM (APEX_SERVICE_TYPE_RECORD,                APEX__SERVICE__TYPE__RECORD);
ASSERT_ENUM (APEX_SERVICE_TYPE_STATE,                 APEX__SERVICE__TYPE__STATE);
